#!/bin/tcsh
# Datei times.tcsh: Shell-Skript, das den Parser "pascal" im aktuellen
# Verzeichnis 100 mal mit der Eingabedatei aufruft, die dem Skript als
# Argument übergeben wurde. Für jede Ausführung wird an eine Datei
# <Eingabename>.time die Ausgabe des time-Kommandos angefügt.

# Teste, ob ein gültiger Dateiname übergeben wurde:
if ( $#argv != 1 ) then
	echo Falsche Anzahl \($#argv\) von Parametern!
	exit -1
endif
if ( ! -f $1 ) then
	echo Datei $1 existiert nicht!
	exit -1
endif

# Falls keine Datei pascal im aktuellen Verzeichnis existiert, muss
# der Parser anscheinend erstmal erzeugt werden:
if ( ! -f pascal ) then
	echo Parser \"pascal\" existiert nicht!
	exit -1
endif

# Zur Initialisierung: Lass den Parser 4 mal ohne Zeitmessung laufen.
./pascal < $1 >& /dev/null
./pascal < $1 >& /dev/null
./pascal < $1 >& /dev/null
./pascal < $1 >& /dev/null

# Rufe das Skript auf, das den Parser mit Eingabe $1 100x laufen lässt
(time ./run_pascal.csh $1) > $1.time

# Bestimme den Durchschnitt
awk '{print "(" $1 " + " $2 ") / 100 = " ($1+$2) / 100}' < $1.time > $1.time_avg

exit:
	echo $0 : Fertig!
