/* Grammar taken from E. Ukkonen: Upper Bounds on the Size of LR(k) Parsers.
 * Here: Grammar G_2.
 */
%{
#include <stdio.h>

int yylex (void); // forward

void
yyerror (char const *s)
{
  fprintf(stderr, "%s\n", s);
}

%}

%token a1 a2
%token b1 b2
%start S

%%

S :
    A1 {}
  | A2 {}
  ;

A1 :
    a1 B1 {}
  | b1 {}
  | a2 A1 {}
  ;

A2 :
    a2 B2 {}
  | b2 {}
  | a1 A2 {}
  ;

B1 :
    b1 {}
  | a1 B1 {}
  | a2 B1 {}
  ;

B2 :
    b2 {}
  | a1 B2 {}
  | a2 B2 {}
  ;

%%

int
main (void)
{
  return yyparse();
}
