/* Grammar taken from E. Ukkonen: Upper Bounds on the Size of LR(k) Parsers.
 * Here: Grammar G_4.
 */
%{
#include <stdio.h>

int yylex (void); // forward

void
yyerror (char const *s)
{
  fprintf(stderr, "%s\n", s);
}

%}

%token a1 a2 a3 a4
%token b1 b2 b3 b4
%start S

%%

S :
    A1 {}
  | A2 {}
  | A3 {}
  | A4 {}
  ;

A1 :
    a1 B1 {}
  | b1 {}
  | a2 A1 {}
  | a3 A1 {}
  | a4 A1 {}
  ;

A2 :
    a2 B2 {}
  | b2 {}
  | a1 A2 {}
  | a3 A2 {}
  | a4 A2 {}
  ;

A3 :
    a3 B3 {}
  | b3 {}
  | a1 A3 {}
  | a2 A3 {}
  | a4 A3 {}
  ;

A4 :
    a4 B4 {}
  | b4 {}
  | a1 A4 {}
  | a2 A4 {}
  | a3 A4 {}
  ;

B1 :
    b1 {}
  | a1 B1 {}
  | a2 B1 {}
  | a3 B1 {}
  | a4 B1 {}
  ;

B2 :
    b2 {}
  | a1 B2 {}
  | a2 B2 {}
  | a3 B2 {}
  | a4 B2 {}
  ;

B3 :
    b3 {}
  | a1 B3 {}
  | a2 B3 {}
  | a3 B3 {}
  | a4 B3 {}
  ;

B4 :
    b4 {}
  | a1 B4 {}
  | a2 B4 {}
  | a3 B4 {}
  | a4 B4 {}
  ;

%%

int
main (void)
{
  return yyparse();
}
