/* Grammar taken from E. Ukkonen: Upper Bounds on the Size of LR(k) Parsers.
 * Here: Grammar G_6.
 */
%{
#include <stdio.h>

int yylex (void); // forward

void
yyerror (char const *s)
{
  fprintf(stderr, "%s\n", s);
}

%}

%token a1 a2 a3 a4 a5 a6
%token b1 b2 b3 b4 b5 b6
%start S

%%

S :
    A1 {}
  | A2 {}
  | A3 {}
  | A4 {}
  | A5 {}
  | A6 {}
  ;

A1 :
    a1 B1 {}
  | b1 {}
  | a2 A1 {}
  | a3 A1 {}
  | a4 A1 {}
  | a5 A1 {}
  | a6 A1 {}
  ;

A2 :
    a2 B2 {}
  | b2 {}
  | a1 A2 {}
  | a3 A2 {}
  | a4 A2 {}
  | a5 A2 {}
  | a6 A2 {}
  ;

A3 :
    a3 B3 {}
  | b3 {}
  | a1 A3 {}
  | a2 A3 {}
  | a4 A3 {}
  | a5 A3 {}
  | a6 A3 {}
  ;

A4 :
    a4 B4 {}
  | b4 {}
  | a1 A4 {}
  | a2 A4 {}
  | a3 A4 {}
  | a5 A4 {}
  | a6 A4 {}
  ;

A5 :
    a5 B5 {}
  | b5 {}
  | a1 A5 {}
  | a2 A5 {}
  | a3 A5 {}
  | a4 A5 {}
  | a6 A5 {}
  ;

A6 :
    a6 B6 {}
  | b6 {}
  | a1 A6 {}
  | a2 A6 {}
  | a3 A6 {}
  | a4 A6 {}
  | a5 A6 {}
  ;

B1 :
    b1 {}
  | a1 B1 {}
  | a2 B1 {}
  | a3 B1 {}
  | a4 B1 {}
  | a5 B1 {}
  | a6 B1 {}
  ;

B2 :
    b2 {}
  | a1 B2 {}
  | a2 B2 {}
  | a3 B2 {}
  | a4 B2 {}
  | a5 B2 {}
  | a6 B2 {}
  ;

B3 :
    b3 {}
  | a1 B3 {}
  | a2 B3 {}
  | a3 B3 {}
  | a4 B3 {}
  | a5 B3 {}
  | a6 B3 {}
  ;

B4 :
    b4 {}
  | a1 B4 {}
  | a2 B4 {}
  | a3 B4 {}
  | a4 B4 {}
  | a5 B4 {}
  | a6 B4 {}
  ;

B5 :
    b5 {}
  | a1 B5 {}
  | a2 B5 {}
  | a3 B5 {}
  | a4 B5 {}
  | a5 B5 {}
  | a6 B5 {}
  ;

B6 :
    b6 {}
  | a1 B6 {}
  | a2 B6 {}
  | a3 B6 {}
  | a4 B6 {}
  | a5 B6 {}
  | a6 B6 {}
  ;

%%

int
main (void)
{
  return yyparse();
}
