/* Grammar taken from E. Ukkonen: Upper Bounds on the Size of LR(k) Parsers.
 * Here: Grammar G_9.
 */
%{
#include <stdio.h>

int yylex (void); // forward

void
yyerror (char const *s)
{
  fprintf(stderr, "%s\n", s);
}

%}

%token a1 a2 a3 a4 a5 a6 a7 a8 a9
%token b1 b2 b3 b4 b5 b6 b7 b8 b9
%start S

%%

S :
    A1 {}
  | A2 {}
  | A3 {}
  | A4 {}
  | A5 {}
  | A6 {}
  | A7 {}
  | A8 {}
  | A9 {}
  ;

A1 :
    a1 B1 {}
  | b1 {}
  | a2 A1 {}
  | a3 A1 {}
  | a4 A1 {}
  | a5 A1 {}
  | a6 A1 {}
  | a7 A1 {}
  | a8 A1 {}
  | a9 A1 {}
  ;

A2 :
    a2 B2 {}
  | b2 {}
  | a1 A2 {}
  | a3 A2 {}
  | a4 A2 {}
  | a5 A2 {}
  | a6 A2 {}
  | a7 A2 {}
  | a8 A2 {}
  | a9 A2 {}
  ;

A3 :
    a3 B3 {}
  | b3 {}
  | a1 A3 {}
  | a2 A3 {}
  | a4 A3 {}
  | a5 A3 {}
  | a6 A3 {}
  | a7 A3 {}
  | a8 A3 {}
  | a9 A3 {}
  ;

A4 :
    a4 B4 {}
  | b4 {}
  | a1 A4 {}
  | a2 A4 {}
  | a3 A4 {}
  | a5 A4 {}
  | a6 A4 {}
  | a7 A4 {}
  | a8 A4 {}
  | a9 A4 {}
  ;

A5 :
    a5 B5 {}
  | b5 {}
  | a1 A5 {}
  | a2 A5 {}
  | a3 A5 {}
  | a4 A5 {}
  | a6 A5 {}
  | a7 A5 {}
  | a8 A5 {}
  | a9 A5 {}
  ;

A6 :
    a6 B6 {}
  | b6 {}
  | a1 A6 {}
  | a2 A6 {}
  | a3 A6 {}
  | a4 A6 {}
  | a5 A6 {}
  | a7 A6 {}
  | a8 A6 {}
  | a9 A6 {}
  ;

A7 :
    a7 B7 {}
  | b7 {}
  | a1 A7 {}
  | a2 A7 {}
  | a3 A7 {}
  | a4 A7 {}
  | a5 A7 {}
  | a6 A7 {}
  | a8 A7 {}
  | a9 A7 {}
  ;

A8 :
    a8 B8 {}
  | b8 {}
  | a1 A8 {}
  | a2 A8 {}
  | a3 A8 {}
  | a4 A8 {}
  | a5 A8 {}
  | a6 A8 {}
  | a7 A8 {}
  | a9 A8 {}
  ;

A9 :
    a9 B9 {}
  | b9 {}
  | a1 A9 {}
  | a2 A9 {}
  | a3 A9 {}
  | a4 A9 {}
  | a5 A9 {}
  | a6 A9 {}
  | a7 A9 {}
  | a8 A9 {}
  ;

B1 :
    b1 {}
  | a1 B1 {}
  | a2 B1 {}
  | a3 B1 {}
  | a4 B1 {}
  | a5 B1 {}
  | a6 B1 {}
  | a7 B1 {}
  | a8 B1 {}
  | a9 B1 {}
  ;

B2 :
    b2 {}
  | a1 B2 {}
  | a2 B2 {}
  | a3 B2 {}
  | a4 B2 {}
  | a5 B2 {}
  | a6 B2 {}
  | a7 B2 {}
  | a8 B2 {}
  | a9 B2 {}
  ;

B3 :
    b3 {}
  | a1 B3 {}
  | a2 B3 {}
  | a3 B3 {}
  | a4 B3 {}
  | a5 B3 {}
  | a6 B3 {}
  | a7 B3 {}
  | a8 B3 {}
  | a9 B3 {}
  ;

B4 :
    b4 {}
  | a1 B4 {}
  | a2 B4 {}
  | a3 B4 {}
  | a4 B4 {}
  | a5 B4 {}
  | a6 B4 {}
  | a7 B4 {}
  | a8 B4 {}
  | a9 B4 {}
  ;

B5 :
    b5 {}
  | a1 B5 {}
  | a2 B5 {}
  | a3 B5 {}
  | a4 B5 {}
  | a5 B5 {}
  | a6 B5 {}
  | a7 B5 {}
  | a8 B5 {}
  | a9 B5 {}
  ;

B6 :
    b6 {}
  | a1 B6 {}
  | a2 B6 {}
  | a3 B6 {}
  | a4 B6 {}
  | a5 B6 {}
  | a6 B6 {}
  | a7 B6 {}
  | a8 B6 {}
  | a9 B6 {}
  ;

B7 :
    b7 {}
  | a1 B7 {}
  | a2 B7 {}
  | a3 B7 {}
  | a4 B7 {}
  | a5 B7 {}
  | a6 B7 {}
  | a7 B7 {}
  | a8 B7 {}
  | a9 B7 {}
  ;

B8 :
    b8 {}
  | a1 B8 {}
  | a2 B8 {}
  | a3 B8 {}
  | a4 B8 {}
  | a5 B8 {}
  | a6 B8 {}
  | a7 B8 {}
  | a8 B8 {}
  | a9 B8 {}
  ;

B9 :
    b9 {}
  | a1 B9 {}
  | a2 B9 {}
  | a3 B9 {}
  | a4 B9 {}
  | a5 B9 {}
  | a6 B9 {}
  | a7 B9 {}
  | a8 B9 {}
  | a9 B9 {}
  ;

%%

int
main (void)
{
  return yyparse();
}
